<template>
    <split class='app-workflow-exp-bar' v-model="split">
        <div slot='left'>
<#if ctrl.isShowTitleBar()>
            <div class='workflow-exp-bar-header'>
                <div><icon type='ios-home-outline'/><#if ctrl.getTitle() == ''>流程导航栏<#else>${ctrl.getTitle()}</#if></div>
            </div>
</#if>
<#if ctrl.isEnableSearch()>
            <div class='search-content'>
                <i-input :search="true"
                    @on-change="($event: any) => { this.srffilter = $event.target.value; }"
                    @on-search="onSearch">
                </i-input>
            </div>
</#if>
            <div class='<#if ctrl.isShowTitleBar()>workflow-exp-content<#else>workflow-exp-content2</#if>'>
                <el-menu class="el-menu-vertical-demo" @select="select">
<#assign psworkflow = ctrl.getPSWorkflow()/>
                <el-submenu index="wfstep">
                  <template slot="title">
                    <i class="el-icon-location"></i>
                    <span slot="title">${psworkflow.name}</span>
                  </template>
<#if psworkflow.getWFStepPSCodeList?? && psworkflow.getWFStepPSCodeList()??>
  <#list psworkflow.getWFStepPSCodeList().getAllPSCodeItems() as step>
                  <el-menu-item index="wfstep-${step.value}">${step.getName()}</el-menu-item>
  </#list>
</#if>
                </el-submenu>
              </el-menu>
            </div>
        </div>
        <div slot='right'>
            <component 
              v-if="selection && !Object.is(this.selection.viewName, '')" 
              :is="selection.viewName"
              class="viewcontainer2"
              :viewDefaultUsage="false"
              :viewdata="JSON.stringify(selection.data)"
              @viewdataschange="onViewDatasChange"
              @viewdatasactivated="viewDatasActivated"
              @viewload="onViewLoad">
            </component>
        </div>
    </split>
</template>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return {};
    }


    /**
     * 选中数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public selection: any = {};


    /**
     * 过滤值
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public srffilter: string = '';

    /**
     * 关联视图信息集合
     *
     * @public
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public refViews: any = [
<#list view.getAllRelatedPSAppViews() as refview>
  <#if refview.getWFStepValue??>
        {
          viewName:"${srffilepath2(refview.codeName)}",
          wfstepValue:"${refview.getWFStepValue()}",
        },
  </#if>
</#list>
    ];


    /**
     * 分割宽度
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public split: number = 0.2;

    /**
     * 获取关系项视图
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public select(index: any, indexs: any[]) {
        this.refViews.some((item:any) =>{
            if(Object.is("wfstep-"+item.wfstepValue, index)){
                this.selection = { viewName: item.viewName };
                return true;
            }
        });
    }

    /**
     * vue 声明周期
     *
     * @memberof  ${srfclassname('${ctrl.codeName}')}
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }    

    /**
     * 视图数据变化
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onViewDatasChange($event: any): void {
        this.$emit('selectionchange', $event);
    }

    /**
     * 视图数据被激活
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public viewDatasActivated($event: any): void {
        this.$emit('activated', $event);
    }

    /**
     * 视图数据加载完成
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onViewLoad($event: any): void {
        this.$emit('load', $event);
    }
    
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>
